// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020-2021 Florian Schmaus
#pragma once

#include <string>

#include "emper-config.h"

namespace emper {

static const bool STATS =
#ifdef EMPER_STATS
		true
#else
		false
#endif
		;

template <typename C>
void statsIncr(C& counter) {
	if constexpr (STATS) {
		counter++;
	}
}

template <typename C>
void statsAdd(C& counter, long a) {
	if constexpr (STATS) {
		counter += a;
	}
}

static const bool WORKER_SLEEP =
#ifdef EMPER_WORKER_SLEEP
		true
#else
		false
#endif
		;

enum class WorkerWakeupStrategy {
	one,
	all,
};

static const enum WorkerWakeupStrategy WORKER_WAKEUP_STRATEGY =
		WorkerWakeupStrategy::EMPER_WORKER_WAKEUP_STRATEGY;

static const bool LIBURCU =
#ifdef EMPER_LIBURCU
		true
#else
		false
#endif
		;

static const bool DEBUG =
#ifndef NDEBUG
		true
#else
		false
#endif
		;

static const bool LOG_TIMESTAMP =
#ifdef EMPER_LOG_TIMESTAMP
		true
#else
		false
#endif
		;

static const bool OVERFLOW_QUEUE =
#ifdef EMPER_OVERFLOW_QUEUE
		true
#else
		false
#endif
		;

static const bool CHECK_ANYWHERE_QUEUE_WHILE_STEALING =
#ifdef EMPER_CHECK_ANYWHERE_QUEUE_WHILE_STEALING
		true
#else
		false
#endif
		;

auto getFullVersion() -> std::string;

static const bool BLOCKED_CONTEXT_SET =
#ifdef EMPER_BLOCKED_CONTEXT_SET
		DEBUG
#else
		false
#endif
		;

static const bool IO =
#ifdef EMPER_IO
		true
#else
		false
#endif
		;

static const bool IO_URING_SQPOLL =
#ifdef EMPER_IO_URING_SQPOLL
		true
#else
		false
#endif
		;

static const bool IO_URING_SHARED_WQ =
#ifdef EMPER_IO_URING_SHARED_WQ
		true
#else
		false
#endif
		;

enum class IoCompleterBehavior {
	schedule,
	wakeup,
	none,
};

static const enum IoCompleterBehavior IO_COMPLETER_BEHAVIOR =
		IoCompleterBehavior::EMPER_IO_COMPLETER_BEHAVIOR;

static const bool SET_AFFINITY_ON_BLOCK =
#ifdef EMPER_SET_AFFINITY_ON_BLOCK
		true
#else
		false
#endif
		;

static const bool HAS_FS_PATH =
#ifdef EMPER_HAS_FS_PATH
		true
#else
		false
#endif
		;

}	 // namespace emper
