// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020-2021 Florian Schmaus
#include "Scheduler.hpp"

#include "CallerEnvironment.hpp"
#include "Runtime.hpp"
#include "RuntimeStrategy.hpp"

Scheduler::Scheduler(Runtime& runtime, RuntimeStrategy& strategy)
		: runtime(runtime), dispatcher(strategy.getDispatcher()) {}

void Scheduler::addNewWorkerHook(const std::function<void(workerid_t)>& hook) {
	runtime.addNewWorkerHook(hook);
}

template <CallerEnvironment callerEnvironment>
void Scheduler::wakeupSleepingWorkers() {
	runtime.wakeupSleepingWorkers<callerEnvironment>();
}

// show the compiler our template incarnations
template void Scheduler::wakeupSleepingWorkers<CallerEnvironment::EMPER>();
template void Scheduler::wakeupSleepingWorkers<CallerEnvironment::ANYWHERE>();
