// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020-2021 Florian Schmaus, Florian Fischer
#pragma once

#ifdef EMPER_MUTEX_LOCKED_UNBOUNDED_QUEUE
#include "lib/adt/MutexUnboundedQueue.hpp"

#elif defined EMPER_SHARED_MUTEX_LOCKED_UNBOUNDED_QUEUE
#include "lib/adt/SharedMutexUnboundedQueue.hpp"

#elif defined EMPER_RWLOCK_LOCKED_UNBOUNDED_QUEUE
#include "lib/adt/RwLockUnboundedQueue.hpp"

#elif defined EMPER_BOOST_SHARED_MUTEX_LOCKED_UNBOUNDED_QUEUE
#include "lib/adt/BoostSharedMutexUnboundedQueue.hpp"

#else
#error Unknown LockedUnboundedQueue implementation
#endif

namespace lib::adt {
template <typename I>
#ifdef EMPER_MUTEX_LOCKED_UNBOUNDED_QUEUE
using LockedUnboundedQueue = MutexUnboundedQueue<I>;

#elif defined EMPER_SHARED_MUTEX_LOCKED_UNBOUNDED_QUEUE
using LockedUnboundedQueue = SharedMutexUnboundedQueue<I>;

#elif defined EMPER_RWLOCK_LOCKED_UNBOUNDED_QUEUE
using LockedUnboundedQueue = RwLockUnboundedQueue<I>;

#elif defined EMPER_BOOST_SHARED_MUTEX_LOCKED_UNBOUNDED_QUEUE
using LockedUnboundedQueue = BoostSharedMutexUnboundedQueue<I>;
#endif
}	 // namespace lib::adt
