// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2021 Florian Fischer
#pragma once

#ifdef EMPER_SEMAPHORE_SLEEP_STRATEGY
#include "sleep_strategy/SemaphoreWorkerSleepStrategy.hpp"

#elif defined EMPER_PIPE_SLEEP_STRATEGY
#include "sleep_strategy/PipeSleepStrategy.hpp"

#else
#error Unknown WorkerSleepStrategy implementation
#endif

namespace emper::sleep_strategy {

#ifdef EMPER_SEMAPHORE_SLEEP_STRATEGY
using WorkerSleepStrategy = SemaphoreWorkerSleepStrategy;

#elif defined EMPER_PIPE_SLEEP_STRATEGY
using WorkerSleepStrategy = PipeSleepStrategy;
#endif
}	 // namespace emper::sleep_strategy
