// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020-2021 Florian Schmaus
#pragma once

#include <functional>

#include "RuntimeStrategy.hpp"
#include "WorkerLocalData.hpp"

class AbstractWorkStealingScheduler;
class AbstractWorkStealingStats;
class AbstractWorkStealingWorkerStats;
class Runtime;

class AbstractWorkStealingStrategy : public RuntimeStrategy {
 public:
 private:
	static thread_local AbstractWorkStealingWorkerStats stats;

	WorkerLocalData<AbstractWorkStealingWorkerStats> allWorkerStats;

 protected:
	AbstractWorkStealingStrategy(Runtime& runtime) : allWorkerStats([] { return &stats; }, runtime) {}
	~AbstractWorkStealingStrategy() override = default;

	friend AbstractWorkStealingScheduler;
	friend AbstractWorkStealingStats;
};
