// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020-2021 Florian Schmaus
#pragma once

#include <cstdint>

struct LawsWorkerStats {
	uint64_t scheduledFibersToPriority = 0;
	uint64_t dispatchedFibersFromPriority = 0;
	uint64_t dispatchedFibersFromLocal = 0;
	uint64_t dispatchedFibersFromHintLocal = 0;
	uint64_t dispatchedFibersFromHintAnywhere = 0;
	uint64_t dispatchedFibersStolen = 0;
	uint64_t dispatchedFibersFromAnywhereQueue = 0;

	auto operator+=(const LawsWorkerStats& other) -> LawsWorkerStats& {
		scheduledFibersToPriority += other.scheduledFibersToPriority;
		dispatchedFibersFromPriority += other.dispatchedFibersFromPriority;
		dispatchedFibersFromLocal += other.dispatchedFibersFromLocal;
		dispatchedFibersFromHintLocal += other.dispatchedFibersFromHintLocal;
		dispatchedFibersFromHintAnywhere += other.dispatchedFibersFromHintAnywhere;
		dispatchedFibersStolen += other.dispatchedFibersStolen;
		dispatchedFibersFromAnywhereQueue += other.dispatchedFibersFromAnywhereQueue;
		return *this;
	}
};
