// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020 Florian Schmaus
#include "WsDispatcher.hpp"

#include "NextFiberResult.hpp"
#include "Runtime.hpp"	// for Runtime

class Fiber;

void WsDispatcher::dispatchLoop() {
	while (true) {
		NextFiberResult next = runtime.nextFiber();
		Fiber* const fiber = next.fiber;
		if (!fiber) {
			dispatchLoopDoSleep();

			continue;
		}

		dispatch(fiber);

		recycle(fiber);
	}
}
