// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020-2021 Florian Schmaus
#pragma once

#include "CallerEnvironment.hpp"
#include "NextFiberResult.hpp"
#include "strategies/AbstractWorkStealingScheduler.hpp"

class Fiber;
class Runtime;
class RuntimeStrategy;

class WsScheduler : public AbstractWorkStealingScheduler {
 protected:
	void scheduleInternal(Fiber& fiber) override { scheduleViaWorkStealing(fiber); }
	void scheduleFromAnywhereInternal(Fiber& fiber) override {
		enqueueInAnywhereQueue(fiber);
		onNewWork<CallerEnvironment::ANYWHERE>();
	}

	void scheduleFromAnywhereInternal(Fiber** fibers, unsigned count) override {
		insertInAnywhereQueue(fibers, count);
		onNewWork<CallerEnvironment::ANYWHERE>();
	}

 public:
	WsScheduler(Runtime& runtime, RuntimeStrategy& strategy);

	auto nextFiber() -> NextFiberResult override { return nextFiberResultViaWorkStealing(); };
};
