// SPDX-License-Identifier: LGPL-3.0-or-later
// Copyright © 2020-2021 Florian Schmaus
#include "BinaryPrivateSemaphore.hpp"		 // for BPS
#include "CountingPrivateSemaphore.hpp"	 // for CPS
#include "emper.hpp"										 // for spawn

void emperTest() {
	CPS cps;
	BPS bps1, bps2;

	const int ITERATIONS = 100;

	spawn(
			[&bps1, &bps2] {
				for (int i = 0; i < ITERATIONS; ++i) {
					bps1.wait();
					bps1.reset();
					bps2.signal();
				}
			},
			cps);

	spawn(
			[&bps1, &bps2] {
				for (int i = 0; i < ITERATIONS; ++i) {
					bps1.signal();
					bps2.wait();
					bps2.reset();
				}
			},
			cps);

	// Wait for the fibers to finish.
	cps.wait();
}
